diff --git a/pengine/test10/whitebox-fail3.exp b/pengine/test10/whitebox-fail3.exp
index 1cbd24ad1..8ddaba064 100644
--- a/pengine/test10/whitebox-fail3.exp
+++ b/pengine/test10/whitebox-fail3.exp
@@ -1,7 +1,7 @@
 <transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
   <synapse id="0">
     <action_set>
-      <rsc_op id="2" operation="start" operation_key="vm_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
+      <rsc_op id="3" operation="start" operation_key="vm_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
         <primitive id="vm" class="ocf" provider="heartbeat" type="VirtualDomain"/>
         <attributes CRM_meta_on_node="dvossel-laptop2" CRM_meta_on_node_uuid="24815808" CRM_meta_remote_node="18builder" CRM_meta_timeout="20000" config="/home/dvossel/virtual_machines/18builder.xml"  hypervisor="qemu:///system"/>
       </rsc_op>
@@ -10,23 +10,23 @@
   </synapse>
   <synapse id="1">
     <action_set>
-      <rsc_op id="4" operation="start" operation_key="FAKE_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
+      <rsc_op id="5" operation="start" operation_key="FAKE_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
         <primitive id="FAKE" class="ocf" provider="pacemaker" type="Dummy"/>
         <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="18builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="3" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="4" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="2">
     <action_set>
-      <rsc_op id="3" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
+      <rsc_op id="4" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
         <primitive id="FAKE" class="ocf" provider="pacemaker" type="Dummy"/>
         <attributes CRM_meta_on_node="dvossel-laptop2" CRM_meta_on_node_uuid="24815808" CRM_meta_timeout="20000" />
       </rsc_op>
@@ -35,54 +35,54 @@
   </synapse>
   <synapse id="3">
     <action_set>
-      <rsc_op id="10" operation="monitor" operation_key="W:1_monitor_10000" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
+      <rsc_op id="11" operation="monitor" operation_key="W:1_monitor_10000" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
         <primitive id="W" long-id="W:1" class="ocf" provider="pacemaker" type="Stateful"/>
         <attributes CRM_meta_clone="1" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="18builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="9" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
+        <rsc_op id="10" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
       </trigger>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="4">
     <action_set>
-      <rsc_op id="9" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
+      <rsc_op id="10" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
         <primitive id="W" long-id="W:1" class="ocf" provider="pacemaker" type="Stateful"/>
         <attributes CRM_meta_clone="1" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="18builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="11" operation="start" operation_key="W-master_start_0"/>
+        <pseudo_event id="12" operation="start" operation_key="W-master_start_0"/>
       </trigger>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="5" priority="1000000">
     <action_set>
-      <pseudo_event id="12" operation="running" operation_key="W-master_running_0">
+      <pseudo_event id="13" operation="running" operation_key="W-master_running_0">
         <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="9" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
+        <rsc_op id="10" operation="start" operation_key="W:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
       </trigger>
       <trigger>
-        <pseudo_event id="11" operation="start" operation_key="W-master_start_0"/>
+        <pseudo_event id="12" operation="start" operation_key="W-master_start_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="6">
     <action_set>
-      <pseudo_event id="11" operation="start" operation_key="W-master_start_0">
+      <pseudo_event id="12" operation="start" operation_key="W-master_start_0">
         <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
@@ -90,54 +90,54 @@
   </synapse>
   <synapse id="7">
     <action_set>
-      <rsc_op id="24" operation="monitor" operation_key="X:1_monitor_10000" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
+      <rsc_op id="25" operation="monitor" operation_key="X:1_monitor_10000" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
         <primitive id="X" long-id="X:1" class="ocf" provider="pacemaker" type="Stateful"/>
         <attributes CRM_meta_clone="1" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="18builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="23" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
+        <rsc_op id="24" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
       </trigger>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="8">
     <action_set>
-      <rsc_op id="23" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
+      <rsc_op id="24" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2">
         <primitive id="X" long-id="X:1" class="ocf" provider="pacemaker" type="Stateful"/>
         <attributes CRM_meta_clone="1" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="18builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="25" operation="start" operation_key="X-master_start_0"/>
+        <pseudo_event id="26" operation="start" operation_key="X-master_start_0"/>
       </trigger>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="9" priority="1000000">
     <action_set>
-      <pseudo_event id="26" operation="running" operation_key="X-master_running_0">
+      <pseudo_event id="27" operation="running" operation_key="X-master_running_0">
         <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="23" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
+        <rsc_op id="24" operation="start" operation_key="X:1_start_0" on_node="18builder" on_node_uuid="18builder" router_node="dvossel-laptop2"/>
       </trigger>
       <trigger>
-        <pseudo_event id="25" operation="start" operation_key="X-master_start_0"/>
+        <pseudo_event id="26" operation="start" operation_key="X-master_start_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="10">
     <action_set>
-      <pseudo_event id="25" operation="start" operation_key="X-master_start_0">
+      <pseudo_event id="26" operation="start" operation_key="X-master_start_0">
         <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
@@ -145,39 +145,51 @@
   </synapse>
   <synapse id="11">
     <action_set>
-      <rsc_op id="34" operation="monitor" operation_key="18builder_monitor_30000" on_node="dvossel-laptop2" on_node_uuid="24815808">
+      <rsc_op id="35" operation="monitor" operation_key="18builder_monitor_30000" on_node="dvossel-laptop2" on_node_uuid="24815808">
         <primitive id="18builder" class="ocf" provider="pacemaker" type="remote"/>
         <attributes CRM_meta_container="vm" CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="dvossel-laptop2" CRM_meta_on_node_uuid="24815808" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="12">
     <action_set>
-      <rsc_op id="33" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
+      <rsc_op id="34" operation="start" operation_key="18builder_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
         <primitive id="18builder" class="ocf" provider="pacemaker" type="remote"/>
         <attributes CRM_meta_container="vm" CRM_meta_name="start" CRM_meta_on_node="dvossel-laptop2" CRM_meta_on_node_uuid="24815808" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="2" operation="start" operation_key="vm_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="2" operation="monitor" operation_key="18builder_monitor_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="start" operation_key="vm_start_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
     <action_set>
+      <rsc_op id="2" operation="monitor" operation_key="18builder_monitor_0" on_node="dvossel-laptop2" on_node_uuid="24815808">
+        <primitive id="18builder" class="ocf" provider="pacemaker" type="remote"/>
+        <attributes CRM_meta_container="vm" CRM_meta_on_node="dvossel-laptop2" CRM_meta_on_node_uuid="24815808" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="14">
+    <action_set>
       <pseudo_event id="1" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="3" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
+        <rsc_op id="4" operation="stop" operation_key="FAKE_stop_0" on_node="dvossel-laptop2" on_node_uuid="24815808"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/whitebox-fail3.summary b/pengine/test10/whitebox-fail3.summary
index 7acf1b6c8..19b2e3d11 100644
--- a/pengine/test10/whitebox-fail3.summary
+++ b/pengine/test10/whitebox-fail3.summary
@@ -24,8 +24,9 @@ Executing cluster transition:
  * Resource action: FAKE            stop on dvossel-laptop2
  * Pseudo action:   W-master_start_0
  * Pseudo action:   X-master_start_0
- * Resource action: 18builder       start on dvossel-laptop2
+ * Resource action: 18builder       monitor on dvossel-laptop2
  * Pseudo action:   all_stopped
+ * Resource action: 18builder       start on dvossel-laptop2
  * Resource action: FAKE            start on 18builder
  * Resource action: W               start on 18builder
  * Pseudo action:   W-master_running_0
diff --git a/pengine/test10/whitebox-migrate1.dot b/pengine/test10/whitebox-migrate1.dot
index b00e272cc..e54df2c1d 100644
--- a/pengine/test10/whitebox-migrate1.dot
+++ b/pengine/test10/whitebox-migrate1.dot
@@ -25,6 +25,10 @@
 "rhel7-node1_migrate_from_0 rhel7-node3" [ style=bold color="green" fontcolor="black"]
 "rhel7-node1_migrate_to_0 rhel7-node2" -> "rhel7-node1_migrate_from_0 rhel7-node3" [ style = bold]
 "rhel7-node1_migrate_to_0 rhel7-node2" [ style=bold color="green" fontcolor="black"]
+"rhel7-node1_monitor_0 rhel7-node3" -> "rhel7-node1_migrate_to_0 rhel7-node2" [ style = bold]
+"rhel7-node1_monitor_0 rhel7-node3" -> "rhel7-node1_start_0 rhel7-node3" [ style = bold]
+"rhel7-node1_monitor_0 rhel7-node3" -> "rhel7-node1_stop_0 rhel7-node2" [ style = bold]
+"rhel7-node1_monitor_0 rhel7-node3" [ style=bold color="green" fontcolor="black"]
 "rhel7-node1_monitor_30000 rhel7-node3" [ style=bold color="green" fontcolor="black"]
 "rhel7-node1_start_0 rhel7-node3" -> "rhel7-node1_monitor_30000 rhel7-node3" [ style = bold]
 "rhel7-node1_start_0 rhel7-node3" [ style=bold color="green" fontcolor="orange"]
